/* Generated from /builddir/build/BUILD/wmi-1.3.14/Samba/source/heimdal/lib/krb5/krb5_err.et */
/* $Id: krb5_err.et,v 1.14 2006/02/13 11:28:22 lha Exp $ */

#include <stddef.h>
#include <com_err.h>
#include "krb5_err.h"

static const char *krb5_error_strings[] = {
	/* 000 */ "No error",
	/* 001 */ "Client's entry in database has expired",
	/* 002 */ "Server's entry in database has expired",
	/* 003 */ "Requested protocol version not supported",
	/* 004 */ "Client's key is encrypted in an old master key",
	/* 005 */ "Server's key is encrypted in an old master key",
	/* 006 */ "Client not found in Kerberos database",
	/* 007 */ "Server not found in Kerberos database",
	/* 008 */ "Principal has multiple entries in Kerberos database",
	/* 009 */ "Client or server has a null key",
	/* 010 */ "Ticket is ineligible for postdating",
	/* 011 */ "Requested effective lifetime is negative or too short",
	/* 012 */ "KDC policy rejects request",
	/* 013 */ "KDC can't fulfill requested option",
	/* 014 */ "KDC has no support for encryption type",
	/* 015 */ "KDC has no support for checksum type",
	/* 016 */ "KDC has no support for padata type",
	/* 017 */ "KDC has no support for transited type",
	/* 018 */ "Clients credentials have been revoked",
	/* 019 */ "Credentials for server have been revoked",
	/* 020 */ "TGT has been revoked",
	/* 021 */ "Client not yet valid - try again later",
	/* 022 */ "Server not yet valid - try again later",
	/* 023 */ "Password has expired",
	/* 024 */ "Preauthentication failed",
	/* 025 */ "Additional pre-authentication required",
	/* 026 */ "Requested server and ticket don't match",
	/* 027 */ "Reserved krb5 error (27)",
	/* 028 */ "Reserved krb5 error (28)",
	/* 029 */ "Reserved krb5 error (29)",
	/* 030 */ "Reserved krb5 error (30)",
	/* 031 */ "Decrypt integrity check failed",
	/* 032 */ "Ticket expired",
	/* 033 */ "Ticket not yet valid",
	/* 034 */ "Request is a replay",
	/* 035 */ "The ticket isn't for us",
	/* 036 */ "Ticket/authenticator don't match",
	/* 037 */ "Clock skew too great",
	/* 038 */ "Incorrect net address",
	/* 039 */ "Protocol version mismatch",
	/* 040 */ "Invalid message type",
	/* 041 */ "Message stream modified",
	/* 042 */ "Message out of order",
	/* 043 */ "Invalid cross-realm ticket",
	/* 044 */ "Key version is not available",
	/* 045 */ "Service key not available",
	/* 046 */ "Mutual authentication failed",
	/* 047 */ "Incorrect message direction",
	/* 048 */ "Alternative authentication method required",
	/* 049 */ "Incorrect sequence number in message",
	/* 050 */ "Inappropriate type of checksum in message",
	/* 051 */ "Policy rejects transited path",
	/* 052 */ "Response too big for UDP, retry with TCP",
	/* 053 */ "Reserved krb5 error (53)",
	/* 054 */ "Reserved krb5 error (54)",
	/* 055 */ "Reserved krb5 error (55)",
	/* 056 */ "Reserved krb5 error (56)",
	/* 057 */ "Reserved krb5 error (57)",
	/* 058 */ "Reserved krb5 error (58)",
	/* 059 */ "Reserved krb5 error (59)",
	/* 060 */ "Generic error (see e-text)",
	/* 061 */ "Field is too long for this implementation",
	/* 062 */ "Client not trusted",
	/* 063 */ "KDC not trusted",
	/* 064 */ "Invalid signature",
	/* 065 */ "DH parameters not accepted",
	/* 066 */ "Reserved krb5 error (66)",
	/* 067 */ "Reserved krb5 error (67)",
	/* 068 */ "Reserved krb5 error (68)",
	/* 069 */ "User to user required",
	/* 070 */ "Cannot verify certificate",
	/* 071 */ "Certificate invalid",
	/* 072 */ "Certificate revoked",
	/* 073 */ "Revocation status unknown",
	/* 074 */ "Revocation status unknown",
	/* 075 */ "Inconsistent key purpose",
	/* 076 */ "Digest in certificate not accepted",
	/* 077 */ "paChecksum must be included",
	/* 078 */ "Digest in signedData not accepted",
	/* 079 */ "Public key encryption not supported",
	/* 080 */ "Reserved krb5 error (80)",
	/* 081 */ "Reserved krb5 error (81)",
	/* 082 */ "Reserved krb5 error (82)",
	/* 083 */ "Reserved krb5 error (83)",
	/* 084 */ "Reserved krb5 error (84)",
	/* 085 */ "Reserved krb5 error (85)",
	/* 086 */ "Reserved krb5 error (86)",
	/* 087 */ "Reserved krb5 error (87)",
	/* 088 */ "Reserved krb5 error (88)",
	/* 089 */ "Reserved krb5 error (89)",
	/* 090 */ "Reserved krb5 error (90)",
	/* 091 */ "Reserved krb5 error (91)",
	/* 092 */ "Reserved krb5 error (92)",
	/* 093 */ "Reserved krb5 error (93)",
	/* 094 */ "Reserved krb5 error (94)",
	/* 095 */ "Reserved krb5 error (95)",
	/* 096 */ "Reserved krb5 error (96)",
	/* 097 */ "Reserved krb5 error (97)",
	/* 098 */ "Reserved krb5 error (98)",
	/* 099 */ "Reserved krb5 error (99)",
	/* 100 */ "Reserved krb5 error (100)",
	/* 101 */ "Reserved krb5 error (101)",
	/* 102 */ "Reserved krb5 error (102)",
	/* 103 */ "Reserved krb5 error (103)",
	/* 104 */ "Reserved krb5 error (104)",
	/* 105 */ "Reserved krb5 error (105)",
	/* 106 */ "Reserved krb5 error (106)",
	/* 107 */ "Reserved krb5 error (107)",
	/* 108 */ "Reserved krb5 error (108)",
	/* 109 */ "Reserved krb5 error (109)",
	/* 110 */ "Reserved krb5 error (110)",
	/* 111 */ "Reserved krb5 error (111)",
	/* 112 */ "Reserved krb5 error (112)",
	/* 113 */ "Reserved krb5 error (113)",
	/* 114 */ "Reserved krb5 error (114)",
	/* 115 */ "Reserved krb5 error (115)",
	/* 116 */ "Reserved krb5 error (116)",
	/* 117 */ "Reserved krb5 error (117)",
	/* 118 */ "Reserved krb5 error (118)",
	/* 119 */ "Reserved krb5 error (119)",
	/* 120 */ "Reserved krb5 error (120)",
	/* 121 */ "Reserved krb5 error (121)",
	/* 122 */ "Reserved krb5 error (122)",
	/* 123 */ "Reserved krb5 error (123)",
	/* 124 */ "Reserved krb5 error (124)",
	/* 125 */ "Reserved krb5 error (125)",
	/* 126 */ "Reserved krb5 error (126)",
	/* 127 */ "Reserved krb5 error (127)",
	/* 128 */ "$Id: krb5_err.et,v 1.14 2006/02/13 11:28:22 lha Exp $",
	/* 129 */ "Invalid flag for file lock mode",
	/* 130 */ "Cannot read password",
	/* 131 */ "Password mismatch",
	/* 132 */ "Password read interrupted",
	/* 133 */ "Invalid character in component name",
	/* 134 */ "Malformed representation of principal",
	/* 135 */ "Can't open/find configuration file",
	/* 136 */ "Improper format of configuration file",
	/* 137 */ "Insufficient space to return complete information",
	/* 138 */ "Invalid message type specified for encoding",
	/* 139 */ "Credential cache name malformed",
	/* 140 */ "Unknown credential cache type",
	/* 141 */ "Matching credential not found",
	/* 142 */ "End of credential cache reached",
	/* 143 */ "Request did not supply a ticket",
	/* 144 */ "Wrong principal in request",
	/* 145 */ "Ticket has invalid flag set",
	/* 146 */ "Requested principal and ticket don't match",
	/* 147 */ "KDC reply did not match expectations",
	/* 148 */ "Clock skew too great in KDC reply",
	/* 149 */ "Client/server realm mismatch in initial ticket request",
	/* 150 */ "Program lacks support for encryption type",
	/* 151 */ "Program lacks support for key type",
	/* 152 */ "Requested encryption type not used in message",
	/* 153 */ "Program lacks support for checksum type",
	/* 154 */ "Cannot find KDC for requested realm",
	/* 155 */ "Kerberos service unknown",
	/* 156 */ "Cannot contact any KDC for requested realm",
	/* 157 */ "No local name found for principal name",
	/* 158 */ "Mutual authentication failed",
	/* 159 */ "Replay cache type is already registered",
	/* 160 */ "No more memory to allocate (in replay cache code)",
	/* 161 */ "Replay cache type is unknown",
	/* 162 */ "Generic unknown RC error",
	/* 163 */ "Message is a replay",
	/* 164 */ "Replay I/O operation failed XXX",
	/* 165 */ "Replay cache type does not support non-volatile storage",
	/* 166 */ "Replay cache name parse/format error",
	/* 167 */ "End-of-file on replay cache I/O",
	/* 168 */ "No more memory to allocate (in replay cache I/O code)",
	/* 169 */ "Permission denied in replay cache code",
	/* 170 */ "I/O error in replay cache i/o code",
	/* 171 */ "Generic unknown RC/IO error",
	/* 172 */ "Insufficient system space to store replay information",
	/* 173 */ "Can't open/find realm translation file",
	/* 174 */ "Improper format of realm translation file",
	/* 175 */ "Can't open/find lname translation database",
	/* 176 */ "No translation available for requested principal",
	/* 177 */ "Improper format of translation database entry",
	/* 178 */ "Cryptosystem internal error",
	/* 179 */ "Key table name malformed",
	/* 180 */ "Unknown Key table type",
	/* 181 */ "Key table entry not found",
	/* 182 */ "End of key table reached",
	/* 183 */ "Cannot write to specified key table",
	/* 184 */ "Error writing to key table",
	/* 185 */ "Cannot find ticket for requested realm",
	/* 186 */ "DES key has bad parity",
	/* 187 */ "DES key is a weak key",
	/* 188 */ "Bad encryption type",
	/* 189 */ "Key size is incompatible with encryption type",
	/* 190 */ "Message size is incompatible with encryption type",
	/* 191 */ "Credentials cache type is already registered.",
	/* 192 */ "Key table type is already registered.",
	/* 193 */ "Credentials cache I/O operation failed XXX",
	/* 194 */ "Credentials cache file permissions incorrect",
	/* 195 */ "No credentials cache file found",
	/* 196 */ "Internal file credentials cache error",
	/* 197 */ "Error writing to credentials cache file",
	/* 198 */ "No more memory to allocate (in credentials cache code)",
	/* 199 */ "Bad format in credentials cache",
	/* 200 */ "No credentials found with supported encryption types",
	/* 201 */ "Invalid KDC option combination (library internal error)",
	/* 202 */ "Request missing second ticket",
	/* 203 */ "No credentials supplied to library routine",
	/* 204 */ "Bad sendauth version was sent",
	/* 205 */ "Bad application version was sent (via sendauth)",
	/* 206 */ "Bad response (during sendauth exchange)",
	/* 207 */ "Server rejected authentication (during sendauth exchange)",
	/* 208 */ "Unsupported preauthentication type",
	/* 209 */ "Required preauthentication key not supplied",
	/* 210 */ "Generic preauthentication failure",
	/* 211 */ "Unsupported replay cache format version number",
	/* 212 */ "Unsupported credentials cache format version number",
	/* 213 */ "Unsupported key table format version number",
	/* 214 */ "Program lacks support for address type",
	/* 215 */ "Message replay detection requires rcache parameter",
	/* 216 */ "Hostname cannot be canonicalized",
	/* 217 */ "Cannot determine realm for host",
	/* 218 */ "Conversion to service principal undefined for name type",
	/* 219 */ "Initial Ticket response appears to be Version 4",
	/* 220 */ "Cannot resolve KDC for requested realm",
	/* 221 */ "Requesting ticket can't get forwardable tickets",
	/* 222 */ "Bad principal name while trying to forward credentials",
	/* 223 */ "Looping detected inside krb5_get_in_tkt",
	/* 224 */ "Configuration file does not specify default realm",
	/* 225 */ "Bad SAM flags in obtain_sam_padata",
	/* 226 */ "Invalid encryption type in SAM challenge",
	/* 227 */ "Missing checksum in SAM challenge",
	/* 228 */ "Bad checksum in SAM challenge",
	/* 229 */ "Reserved krb5 error (229)",
	/* 230 */ "Reserved krb5 error (230)",
	/* 231 */ "Reserved krb5 error (231)",
	/* 232 */ "Reserved krb5 error (232)",
	/* 233 */ "Reserved krb5 error (233)",
	/* 234 */ "Reserved krb5 error (234)",
	/* 235 */ "Reserved krb5 error (235)",
	/* 236 */ "Reserved krb5 error (236)",
	/* 237 */ "Reserved krb5 error (237)",
	/* 238 */ "Program called an obsolete, deleted function",
	/* 239 */ "Reserved krb5 error (239)",
	/* 240 */ "Reserved krb5 error (240)",
	/* 241 */ "Reserved krb5 error (241)",
	/* 242 */ "Reserved krb5 error (242)",
	/* 243 */ "Reserved krb5 error (243)",
	/* 244 */ "Reserved krb5 error (244)",
	/* 245 */ "Invalid key generation parameters from KDC",
	/* 246 */ "Service not available",
	/* 247 */ "Credential cache function not supported",
	/* 248 */ "Invalid format of Kerberos lifetime or clock skew string",
	NULL
};

#define num_errors 249

void initialize_krb5_error_table_r(struct et_list **list)
{
    initialize_error_table_r(list, krb5_error_strings, num_errors, ERROR_TABLE_BASE_krb5);
}

void initialize_krb5_error_table(void)
{
    init_error_table(krb5_error_strings, ERROR_TABLE_BASE_krb5, num_errors);
}
