/* header auto-generated by pidl */

#ifndef _HEADER_dssetup
#define _HEADER_dssetup

enum dssetup_DsRole {
	DS_ROLE_STANDALONE_WORKSTATION=0,
	DS_ROLE_MEMBER_WORKSTATION=1,
	DS_ROLE_STANDALONE_SERVER=2,
	DS_ROLE_MEMBER_SERVER=3,
	DS_ROLE_BACKUP_DC=4,
	DS_ROLE_PRIMARY_DC=5
};

/* bitmap dssetup_DsRoleFlags */
#define DS_ROLE_PRIMARY_DS_RUNNING ( 0x00000001 )
#define DS_ROLE_PRIMARY_DS_MIXED_MODE ( 0x00000002 )
#define DS_ROLE_UPGRADE_IN_PROGRESS ( 0x00000004 )
#define DS_ROLE_PRIMARY_DOMAIN_GUID_PRESENT ( 0x01000000 )

struct dssetup_DsRolePrimaryDomInfoBasic {
	enum dssetup_DsRole role;
	uint32_t flags;
	const char *domain;/* [charset(UTF16),string,unique] */
	const char *dns_domain;/* [string,unique,charset(UTF16)] */
	const char *forest;/* [charset(UTF16),string,unique] */
	struct GUID domain_guid;
};

enum dssetup_DsUpgrade {
	DS_ROLE_NOT_UPGRADING=0,
	DS_ROLE_UPGRADING=1
};

enum dssetup_DsPrevious {
	DS_ROLE_PREVIOUS_UNKNOWN=0,
	DS_ROLE_PREVIOUS_PRIMARY=1,
	DS_ROLE_PREVIOUS_BACKUP=2
};

struct dssetup_DsRoleUpgradeStatus {
	enum dssetup_DsUpgrade upgrading;
	enum dssetup_DsPrevious previous_role;
};

enum dssetup_DsRoleOp {
	DS_ROLE_OP_IDLE=0,
	DS_ROLE_OP_ACTIVE=1,
	DS_ROLE_OP_NEEDS_REBOOT=2
};

struct dssetup_DsRoleOpStatus {
	enum dssetup_DsRoleOp status;
};

enum dssetup_DsRoleInfoLevel {
	DS_ROLE_BASIC_INFORMATION=1,
	DS_ROLE_UPGRADE_STATUS=2,
	DS_ROLE_OP_STATUS=3
};

union dssetup_DsRoleInfo {
	struct dssetup_DsRolePrimaryDomInfoBasic basic;/* [case(DS_ROLE_BASIC_INFORMATION)] */
	struct dssetup_DsRoleUpgradeStatus upgrade;/* [case(DS_ROLE_UPGRADE_STATUS)] */
	struct dssetup_DsRoleOpStatus opstatus;/* [case(DS_ROLE_OP_STATUS)] */
}/* [switch_type(dssetup_DsRoleInfoLevel)] */;


struct dssetup_DsRoleGetPrimaryDomainInformation {
	struct {
		enum dssetup_DsRoleInfoLevel level;
	} in;

	struct {
		union dssetup_DsRoleInfo *info;/* [unique,switch_is(level)] */
		WERROR result;
	} out;

};


struct dssetup_DsRoleDnsNameToFlatName {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleDcAsDc {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleDcAsReplica {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleDemoteDc {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleGetDcOperationProgress {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleGetDcOperationResults {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleCancel {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleServerSaveStateForUpgrade {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleUpgradeDownlevelServer {
	struct {
		WERROR result;
	} out;

};


struct dssetup_DsRoleAbortDownlevelServerUpgrade {
	struct {
		WERROR result;
	} out;

};

#endif /* _HEADER_dssetup */
