/* header auto-generated by pidl */

#include "librpc/gen_ndr/lsa.h"
#include "librpc/gen_ndr/samr.h"
#include "librpc/gen_ndr/security.h"
#ifndef _HEADER_netlogon
#define _HEADER_netlogon

#define MSV1_0_CLEARTEXT_PASSWORD_ALLOWED	( 0x002 )
#define MSV1_0_ALLOW_SERVER_TRUST_ACCOUNT	( 0x020 )
#define MSV1_0_ALLOW_WORKSTATION_TRUST_ACCOUNT	( 0x800 )
#define NETLOGON_NEG_ARCFOUR	( 0x00000004 )
#define NETLOGON_NEG_128BIT	( 0x00004000 )
#define NETLOGON_NEG_SCHANNEL	( 0x40000000 )
struct netr_UasInfo {
	const char *account_name;/* [charset(UTF16),unique,string] */
	uint32_t priv;
	uint32_t auth_flags;
	uint32_t logon_count;
	uint32_t bad_pw_count;
	time_t last_logon;
	time_t last_logoff;
	time_t logoff_time;
	time_t kickoff_time;
	uint32_t password_age;
	time_t pw_can_change;
	time_t pw_must_change;
	const char *computer;/* [string,unique,charset(UTF16)] */
	const char *domain;/* [charset(UTF16),unique,string] */
	const char *script_path;/* [charset(UTF16),string,unique] */
	uint32_t unknown;
};

struct netr_UasLogoffInfo {
	uint32_t duration;
	uint16_t logon_count;
};

struct netr_AcctLockStr {
	uint16_t size;
	uint16_t length;
	uint16_t *bindata;/* [length_is(length/2),size_is(size/2),unique] */
};

struct netr_IdentityInfo {
	struct lsa_String domain_name;
	uint32_t parameter_control;
	uint32_t logon_id_low;
	uint32_t logon_id_high;
	struct lsa_String account_name;
	struct lsa_String workstation;
};

struct netr_PasswordInfo {
	struct netr_IdentityInfo identity_info;
	struct samr_Password lmpassword;
	struct samr_Password ntpassword;
};

struct netr_ChallengeResponse {
	uint16_t length;
	uint16_t size;/* [value(length)] */
	uint8_t *data;/* [length_is(length),size_is(length),unique] */
}/* [flag(LIBNDR_PRINT_ARRAY_HEX)] */;

struct netr_NetworkInfo {
	struct netr_IdentityInfo identity_info;
	uint8_t challenge[8];
	struct netr_ChallengeResponse nt;
	struct netr_ChallengeResponse lm;
}/* [flag(LIBNDR_PRINT_ARRAY_HEX)] */;

union netr_LogonLevel {
	struct netr_PasswordInfo *password;/* [case,unique] */
	struct netr_NetworkInfo *network;/* [unique,case(2)] */
}/* [public,switch_type(uint16)] */;

struct netr_GroupMembership {
	uint32_t rid;
	uint32_t attributes;
}/* [public] */;

struct netr_UserSessionKey {
	uint8_t key[16];
}/* [flag(LIBNDR_PRINT_ARRAY_HEX),public] */;

struct netr_LMSessionKey {
	uint8_t key[8];
}/* [flag(LIBNDR_PRINT_ARRAY_HEX),public] */;

/* bitmap netr_UserFlags */
#define NETLOGON_GUEST ( 0x0001 )
#define NETLOGON_NOENCRYPTION ( 0x0002 )
#define NETLOGON_CACHED_ACCOUNT ( 0x0004 )
#define NETLOGON_USED_LM_PASSWORD ( 0x0008 )
#define NETLOGON_EXTRA_SIDS ( 0x0020 )
#define NETLOGON_SUBAUTH_SESSION_KEY ( 0x0040 )
#define NETLOGON_SERVER_TRUST_ACCOUNT ( 0x0080 )
#define NETLOGON_NTLMV2_ENABLED ( 0x0100 )
#define NETLOGON_RESOURCE_GROUPS ( 0x0200 )
#define NETLOGON_PROFILE_PATH_RETURNED ( 0x0400 )

struct netr_SamBaseInfo {
	NTTIME last_logon;
	NTTIME last_logoff;
	NTTIME acct_expiry;
	NTTIME last_password_change;
	NTTIME allow_password_change;
	NTTIME force_password_change;
	struct lsa_String account_name;
	struct lsa_String full_name;
	struct lsa_String logon_script;
	struct lsa_String profile_path;
	struct lsa_String home_directory;
	struct lsa_String home_drive;
	uint16_t logon_count;
	uint16_t bad_password_count;
	uint32_t rid;
	uint32_t primary_gid;
	struct samr_RidWithAttributeArray groups;
	uint32_t user_flags;
	struct netr_UserSessionKey key;
	struct lsa_StringLarge logon_server;
	struct lsa_StringLarge domain;
	struct dom_sid2 *domain_sid;/* [unique] */
	struct netr_LMSessionKey LMSessKey;
	uint32_t acct_flags;
	uint32_t unknown[7];
};

struct netr_SamInfo2 {
	struct netr_SamBaseInfo base;
};

struct netr_SidAttr {
	struct dom_sid2 *sid;/* [unique] */
	uint32_t attribute;
};

struct netr_SamInfo3 {
	struct netr_SamBaseInfo base;
	uint32_t sidcount;
	struct netr_SidAttr *sids;/* [unique,size_is(sidcount)] */
}/* [public] */;

struct netr_SamInfo6 {
	struct netr_SamBaseInfo base;
	uint32_t sidcount;
	struct netr_SidAttr *sids;/* [size_is(sidcount),unique] */
	struct lsa_String forest;
	struct lsa_String principle;
	uint32_t unknown4[20];
};

struct netr_PacInfo {
	uint32_t pac_size;
	uint8_t *pac;/* [unique,size_is(pac_size)] */
	struct lsa_String logon_domain;
	struct lsa_String logon_server;
	struct lsa_String principal_name;
	uint32_t auth_size;
	uint8_t *auth;/* [size_is(auth_size),unique] */
	struct netr_UserSessionKey user_session_key;
	uint32_t expansionroom[10];
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
};

union netr_Validation {
	struct netr_SamInfo2 *sam2;/* [unique,case(2)] */
	struct netr_SamInfo3 *sam3;/* [unique,case(3)] */
	struct netr_PacInfo *pac;/* [case(4),unique] */
	struct netr_SamInfo6 *sam6;/* [unique,case(6)] */
}/* [switch_type(uint16),public] */;

struct netr_Credential {
	uint8_t data[8];
}/* [public,flag(LIBNDR_PRINT_ARRAY_HEX)] */;

struct netr_Authenticator {
	struct netr_Credential cred;
	time_t timestamp;
}/* [public] */;

struct netr_DELTA_DELETE_USER {
	const char *account_name;/* [string,unique,charset(UTF16)] */
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_USER_KEY16 {
	uint16_t length;
	uint16_t size;/* [value(length)] */
	uint32_t flags;
	struct samr_Password pwd;
};

struct netr_PasswordHistory {
	uint16_t nt_length;
	uint16_t nt_size;
	uint32_t nt_flags;
	uint16_t lm_length;
	uint16_t lm_size;
	uint32_t lm_flags;
	uint8_t *nt_history;
	uint8_t *lm_history;
};

struct netr_USER_KEYS2 {
	struct netr_USER_KEY16 lmpassword;
	struct netr_USER_KEY16 ntpassword;
	struct netr_PasswordHistory lmhistory;
};

struct netr_USER_KEY_UNION {
	struct netr_USER_KEYS2 keys2;
};

struct netr_USER_KEYS {
	uint32_t version;
	struct netr_USER_KEY_UNION keys;
}/* [public] */;

struct netr_USER_PRIVATE_INFO {
	uint8_t SensitiveDataFlag;
	uint32_t DataLength;
	uint8_t *SensitiveData;/* [size_is(DataLength),flag(LIBNDR_PRINT_ARRAY_HEX),unique] */
};

struct netr_DELTA_USER {
	struct lsa_String account_name;
	struct lsa_String full_name;
	uint32_t rid;
	uint32_t primary_gid;
	struct lsa_String home_directory;
	struct lsa_String home_drive;
	struct lsa_String logon_script;
	struct lsa_String description;
	struct lsa_String workstations;
	NTTIME last_logon;
	NTTIME last_logoff;
	struct samr_LogonHours logon_hours;
	uint16_t bad_password_count;
	uint16_t logon_count;
	NTTIME last_password_change;
	NTTIME acct_expiry;
	uint32_t acct_flags;
	struct samr_Password lmpassword;
	struct samr_Password ntpassword;
	uint8_t nt_password_present;
	uint8_t lm_password_present;
	uint8_t password_expired;
	struct lsa_String comment;
	struct lsa_String parameters;
	uint16_t country_code;
	uint16_t code_page;
	struct netr_USER_PRIVATE_INFO user_private_info;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String profile_path;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_DOMAIN {
	struct lsa_String domain_name;
	struct lsa_String comment;
	int64_t force_logoff_time;
	uint16_t min_password_length;
	uint16_t password_history_length;
	int64_t max_password_age;
	int64_t min_password_age;
	uint64_t sequence_num;
	NTTIME domain_create_time;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct netr_AcctLockStr account_lockout;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t logon_to_chgpass;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_GROUP {
	struct lsa_String group_name;
	uint32_t rid;
	uint32_t attributes;
	struct lsa_String description;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_RENAME {
	struct lsa_String OldName;
	struct lsa_String NewName;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_GROUP_MEMBER {
	uint32_t *rids;/* [size_is(num_rids),unique] */
	uint32_t *attribs;/* [size_is(num_rids),unique] */
	uint32_t num_rids;
	uint32_t unknown1;
	uint32_t unknown2;
	uint32_t unknown3;
	uint32_t unknown4;
};

struct netr_DELTA_ALIAS {
	struct lsa_String alias_name;
	uint32_t rid;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String description;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_ALIAS_MEMBER {
	struct lsa_SidArray sids;
	uint32_t unknown1;
	uint32_t unknown2;
	uint32_t unknown3;
	uint32_t unknown4;
};

struct netr_QUOTA_LIMITS {
	uint32_t pagedpoollimit;
	uint32_t nonpagedpoollimit;
	uint32_t minimumworkingsetsize;
	uint32_t maximumworkingsetsize;
	uint32_t pagefilelimit;
	NTTIME timelimit;
};

struct netr_DELTA_POLICY {
	uint32_t maxlogsize;
	NTTIME auditretentionperiod;
	uint8_t auditingmode;
	uint32_t maxauditeventcount;
	uint32_t *eventauditoptions;/* [size_is(maxauditeventcount+1),unique] */
	struct lsa_String primary_domain_name;
	struct dom_sid2 *sid;/* [unique] */
	struct netr_QUOTA_LIMITS quota_limits;
	uint64_t sequence_num;
	NTTIME db_create_time;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_TRUSTED_DOMAIN {
	struct lsa_String domain_name;
	uint32_t num_controllers;
	struct lsa_String *controller_names;/* [unique,size_is(num_controllers)] */
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t posix_offset;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_DELETE_TRUST {
	uint16_t unknown;
};

struct netr_DELTA_ACCOUNT {
	uint32_t privilege_entries;
	uint32_t privilege_control;
	uint32_t *privilege_attrib;/* [unique,size_is(privilege_entries)] */
	struct lsa_String *privilege_name;/* [unique,size_is(privilege_entries)] */
	struct netr_QUOTA_LIMITS quotalimits;
	uint32_t system_flags;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

struct netr_DELTA_DELETE_ACCOUNT {
	uint16_t unknown;
};

struct netr_DELTA_DELETE_SECRET {
	uint16_t unknown;
};

struct netr_CIPHER_VALUE {
	uint32_t len;
	uint32_t maxlen;
	uint8_t *cipher_data;/* [length_is(len),size_is(maxlen),unique] */
};

struct netr_DELTA_SECRET {
	struct netr_CIPHER_VALUE current_cipher;
	NTTIME current_cipher_set_time;
	struct netr_CIPHER_VALUE old_cipher;
	NTTIME old_cipher_set_time;
	uint32_t SecurityInformation;
	struct sec_desc_buf sdbuf;
	struct lsa_String unknown1;
	struct lsa_String unknown2;
	struct lsa_String unknown3;
	struct lsa_String unknown4;
	uint32_t unknown5;
	uint32_t unknown6;
	uint32_t unknown7;
	uint32_t unknown8;
};

enum netr_DeltaEnum {
	NETR_DELTA_DOMAIN=1,
	NETR_DELTA_GROUP=2,
	NETR_DELTA_DELETE_GROUP=3,
	NETR_DELTA_RENAME_GROUP=4,
	NETR_DELTA_USER=5,
	NETR_DELTA_DELETE_USER=6,
	NETR_DELTA_RENAME_USER=7,
	NETR_DELTA_GROUP_MEMBER=8,
	NETR_DELTA_ALIAS=9,
	NETR_DELTA_DELETE_ALIAS=10,
	NETR_DELTA_RENAME_ALIAS=11,
	NETR_DELTA_ALIAS_MEMBER=12,
	NETR_DELTA_POLICY=13,
	NETR_DELTA_TRUSTED_DOMAIN=14,
	NETR_DELTA_DELETE_TRUST=15,
	NETR_DELTA_ACCOUNT=16,
	NETR_DELTA_DELETE_ACCOUNT=17,
	NETR_DELTA_SECRET=18,
	NETR_DELTA_DELETE_SECRET=19,
	NETR_DELTA_DELETE_GROUP2=20,
	NETR_DELTA_DELETE_USER2=21,
	NETR_DELTA_MODIFY_COUNT=22
};

union netr_DELTA_UNION {
	struct netr_DELTA_DOMAIN *domain;/* [case(NETR_DELTA_DOMAIN),unique] */
	struct netr_DELTA_GROUP *group;/* [case(NETR_DELTA_GROUP),unique] */
	struct netr_DELTA_RENAME *rename_group;/* [unique,case(NETR_DELTA_RENAME_GROUP)] */
	struct netr_DELTA_USER *user;/* [case(NETR_DELTA_USER),unique] */
	struct netr_DELTA_RENAME *rename_user;/* [unique,case(NETR_DELTA_RENAME_USER)] */
	struct netr_DELTA_GROUP_MEMBER *group_member;/* [case(NETR_DELTA_GROUP_MEMBER),unique] */
	struct netr_DELTA_ALIAS *alias;/* [unique,case(NETR_DELTA_ALIAS)] */
	struct netr_DELTA_RENAME *rename_alias;/* [unique,case(NETR_DELTA_RENAME_ALIAS)] */
	struct netr_DELTA_ALIAS_MEMBER *alias_member;/* [case(NETR_DELTA_ALIAS_MEMBER),unique] */
	struct netr_DELTA_POLICY *policy;/* [unique,case(NETR_DELTA_POLICY)] */
	struct netr_DELTA_TRUSTED_DOMAIN *trusted_domain;/* [case(NETR_DELTA_TRUSTED_DOMAIN),unique] */
	struct netr_DELTA_DELETE_TRUST delete_trust;/* [case(NETR_DELTA_DELETE_TRUST)] */
	struct netr_DELTA_ACCOUNT *account;/* [unique,case(NETR_DELTA_ACCOUNT)] */
	struct netr_DELTA_DELETE_ACCOUNT delete_account;/* [case(NETR_DELTA_DELETE_ACCOUNT)] */
	struct netr_DELTA_SECRET *secret;/* [case(NETR_DELTA_SECRET),unique] */
	struct netr_DELTA_DELETE_SECRET delete_secret;/* [case(NETR_DELTA_DELETE_SECRET)] */
	struct netr_DELTA_DELETE_USER *delete_group;/* [unique,case(NETR_DELTA_DELETE_GROUP2)] */
	struct netr_DELTA_DELETE_USER *delete_user;/* [unique,case(NETR_DELTA_DELETE_USER2)] */
	uint64_t *modified_count;/* [unique,case(NETR_DELTA_MODIFY_COUNT)] */
}/* [switch_type(netr_DeltaEnum)] */;

union netr_DELTA_ID_UNION {
	uint32_t rid;/* [case(NETR_DELTA_DOMAIN)] */
	struct dom_sid2 *sid;/* [case(NETR_DELTA_POLICY),unique] */
	const char *name;/* [charset(UTF16),unique,case(NETR_DELTA_SECRET),string] */
}/* [switch_type(netr_DeltaEnum)] */;

struct netr_DELTA_ENUM {
	enum netr_DeltaEnum delta_type;
	union netr_DELTA_ID_UNION delta_id_union;/* [switch_is(delta_type)] */
	union netr_DELTA_UNION delta_union;/* [switch_is(delta_type)] */
};

struct netr_DELTA_ENUM_ARRAY {
	uint32_t num_deltas;
	struct netr_DELTA_ENUM *delta_enum;/* [size_is(num_deltas),unique] */
};

struct netr_UAS_INFO_0 {
	uint8_t computer_name[16];
	uint32_t timecreated;
	uint32_t serial_number;
}/* [flag(LIBNDR_PRINT_ARRAY_HEX)] */;

struct netr_AccountBuffer {
	DATA_BLOB blob;/* [flag(LIBNDR_FLAG_REMAINING)] */
};

struct netr_NETLOGON_INFO_1 {
	uint32_t flags;
	uint32_t pdc_connection_status;
};

struct netr_NETLOGON_INFO_2 {
	uint32_t flags;
	uint32_t pdc_connection_status;
	const char *trusted_dc_name;/* [charset(UTF16),string] */
	uint32_t tc_connection_status;
};

struct netr_NETLOGON_INFO_3 {
	uint32_t flags;
	uint32_t logon_attempts;
	uint32_t unknown1;
	uint32_t unknown2;
	uint32_t unknown3;
	uint32_t unknown4;
	uint32_t unknown5;
};

union netr_CONTROL_QUERY_INFORMATION {
	struct netr_NETLOGON_INFO_1 *info1;/* [unique,case] */
	struct netr_NETLOGON_INFO_2 *info2;/* [unique,case(2)] */
	struct netr_NETLOGON_INFO_3 *info3;/* [case(3),unique] */
};

enum netr_LogonControlCode {
	NETLOGON_CONTROL_REDISCOVER=5,
	NETLOGON_CONTROL_TC_QUERY=6,
	NETLOGON_CONTROL_TRANSPORT_NOTIFY=7,
	NETLOGON_CONTROL_SET_DBFLAG=65534
};

union netr_CONTROL_DATA_INFORMATION {
	const char *domain;/* [string,unique,case(NETLOGON_CONTROL_REDISCOVER),charset(UTF16)] */
	uint32_t debug_level;/* [case(NETLOGON_CONTROL_SET_DBFLAG)] */
};

struct netr_DsRGetDCNameInfo {
	const char *dc_unc;/* [string,unique,charset(UTF16)] */
	const char *dc_address;/* [charset(UTF16),string,unique] */
	int32_t dc_address_type;
	struct GUID domain_guid;
	const char *domain_name;/* [charset(UTF16),unique,string] */
	const char *forest_name;/* [charset(UTF16),unique,string] */
	uint32_t dc_flags;
	const char *dc_site_name;/* [charset(UTF16),string,unique] */
	const char *client_site_name;/* [charset(UTF16),unique,string] */
};

struct netr_Blob {
	uint32_t length;
	uint8_t *data;/* [size_is(length),unique] */
};

struct netr_BinaryString {
	uint16_t length;
	uint16_t size;
	uint16_t *data;/* [length_is(length/2),size_is(size/2),unique] */
}/* [flag(LIBNDR_PRINT_ARRAY_HEX)] */;

struct netr_DomainQuery1 {
	struct netr_Blob blob;
	const char *workstation_domain;/* [unique,string,charset(UTF16)] */
	const char *workstation_site;/* [unique,string,charset(UTF16)] */
	const char *unknown1;/* [charset(UTF16),unique,string] */
	const char *unknown2;/* [charset(UTF16),unique,string] */
	const char *unknown3;/* [unique,string,charset(UTF16)] */
	const char *unknown4;/* [charset(UTF16),unique,string] */
	struct netr_BinaryString blob2;
	struct lsa_String product;
	struct lsa_String unknown5;
	struct lsa_String unknown6;
	uint32_t unknown7[4];
};

union netr_DomainQuery {
	struct netr_DomainQuery1 *query1;/* [unique,case] */
};

struct netr_DomainTrustInfo {
	struct lsa_String domainname;
	struct lsa_String fulldomainname;
	struct lsa_String forest;
	struct GUID guid;
	struct dom_sid2 *sid;/* [unique] */
	struct netr_BinaryString unknown1[4];
	uint32_t unknown[4];
};

struct netr_DomainInfo1 {
	struct netr_DomainTrustInfo domaininfo;
	uint32_t num_trusts;
	struct netr_DomainTrustInfo *trusts;/* [size_is(num_trusts),unique] */
	uint32_t unknown[14];
};

union netr_DomainInfo {
	struct netr_DomainInfo1 *info1;/* [unique,case] */
};

struct netr_CryptPassword {
	uint8_t data[512];
	uint32_t length;
}/* [flag(LIBNDR_PRINT_ARRAY_HEX)] */;

/* bitmap netr_TrustFlags */
#define NETR_TRUST_FLAG_IN_FOREST ( 0x00000001 )
#define NETR_TRUST_FLAG_OUTBOUND ( 0x00000002 )
#define NETR_TRUST_FLAG_TREEROOT ( 0x00000004 )
#define NETR_TRUST_FLAG_PRIMARY ( 0x00000008 )
#define NETR_TRUST_FLAG_NATIVE ( 0x00000010 )
#define NETR_TRUST_FLAG_INBOUND ( 0x00000020 )

enum netr_TrustType {
	NETR_TRUST_TYPE_DOWNLEVEL=1,
	NETR_TRUST_TYPE_UPLEVEL=2,
	NETR_TRUST_TYPE_MIT=3,
	NETR_TRUST_TYPE_DCE=4
};

/* bitmap netr_TrustAttributes */
#define NETR_TRUST_ATTRIBUTE_NON_TRANSITIVE ( 0x00000001 )
#define NETR_TRUST_ATTRIBUTE_UPLEVEL_ONLY ( 0x00000002 )
#define NETR_TRUST_ATTRIBUTE_QUARANTINED_DOMAIN ( 0x00000004 )
#define NETR_TRUST_ATTRIBUTE_FOREST_TRANSITIVE ( 0x00000008 )
#define NETR_TRUST_ATTRIBUTE_CROSS_ORGANIZATION ( 0x00000010 )
#define NETR_TRUST_ATTRIBUTE_WITHIN_FOREST ( 0x00000020 )
#define NETR_TRUST_ATTRIBUTE_TREAT_AS_EXTERNAL ( 0x00000040 )

struct netr_DomainTrust {
	const char *netbios_name;/* [string,unique,charset(UTF16)] */
	const char *dns_name;/* [charset(UTF16),string,unique] */
	uint32_t trust_flags;
	uint32_t parent_index;
	enum netr_TrustType trust_type;
	uint32_t trust_attributes;
	struct dom_sid2 *sid;/* [unique] */
	struct GUID guid;
};


struct netr_LogonUasLogon {
	struct {
		const char *server_name;/* [string,unique,charset(UTF16)] */
		const char *account_name;/* [charset(UTF16),string] */
		const char *workstation;/* [string,charset(UTF16)] */
	} in;

	struct {
		struct netr_UasInfo *info;/* [unique] */
		WERROR result;
	} out;

};


struct netr_LogonUasLogoff {
	struct {
		const char *server_name;/* [string,unique,charset(UTF16)] */
		const char *account_name;/* [string,charset(UTF16)] */
		const char *workstation;/* [string,charset(UTF16)] */
	} in;

	struct {
		struct netr_UasLogoffInfo info;
		WERROR result;
	} out;

};


struct netr_LogonSamLogon {
	struct {
		const char *server_name;/* [charset(UTF16),unique,string] */
		const char *computer_name;/* [charset(UTF16),string,unique] */
		struct netr_Authenticator *credential;/* [unique] */
		struct netr_Authenticator *return_authenticator;/* [unique] */
		uint16_t logon_level;
		union netr_LogonLevel logon;/* [switch_is(logon_level)] */
		uint16_t validation_level;
	} in;

	struct {
		struct netr_Authenticator *return_authenticator;/* [unique] */
		union netr_Validation validation;/* [switch_is(validation_level)] */
		uint8_t authoritative;
		NTSTATUS result;
	} out;

};


struct netr_LogonSamLogoff {
	struct {
		const char *server_name;/* [charset(UTF16),string,unique] */
		const char *computer_name;/* [charset(UTF16),unique,string] */
		struct netr_Authenticator *credential;/* [unique] */
		struct netr_Authenticator *return_authenticator;/* [unique] */
		uint16_t logon_level;
		union netr_LogonLevel logon;/* [switch_is(logon_level)] */
	} in;

	struct {
		struct netr_Authenticator *return_authenticator;/* [unique] */
		NTSTATUS result;
	} out;

};


struct netr_ServerReqChallenge {
	struct {
		const char *server_name;/* [string,unique,charset(UTF16)] */
		const char *computer_name;/* [string,charset(UTF16)] */
		struct netr_Credential *credentials;/* [ref] */
	} in;

	struct {
		struct netr_Credential *credentials;/* [ref] */
		NTSTATUS result;
	} out;

};


struct netr_ServerAuthenticate {
	struct {
		const char *server_name;/* [charset(UTF16),string,unique] */
		const char *account_name;/* [charset(UTF16),string] */
		enum netr_SchannelType secure_channel_type;
		const char *computer_name;/* [charset(UTF16),string] */
		struct netr_Credential *credentials;/* [ref] */
	} in;

	struct {
		struct netr_Credential *credentials;/* [ref] */
		NTSTATUS result;
	} out;

};


struct netr_ServerPasswordSet {
	struct {
		const char *server_name;/* [unique,string,charset(UTF16)] */
		const char *account_name;/* [string,charset(UTF16)] */
		enum netr_SchannelType secure_channel_type;
		const char *computer_name;/* [string,charset(UTF16)] */
		struct netr_Authenticator credential;
		struct samr_Password new_password;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		NTSTATUS result;
	} out;

};


struct netr_DatabaseDeltas {
	struct {
		const char *logon_server;/* [charset(UTF16),string] */
		const char *computername;/* [string,charset(UTF16)] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		enum netr_SamDatabaseID database_id;
		uint64_t sequence_num;
		uint32_t preferredmaximumlength;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		uint64_t sequence_num;
		struct netr_DELTA_ENUM_ARRAY *delta_enum_array;/* [unique] */
		NTSTATUS result;
	} out;

};


struct netr_DatabaseSync {
	struct {
		const char *logon_server;/* [string,charset(UTF16)] */
		const char *computername;/* [charset(UTF16),string] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		enum netr_SamDatabaseID database_id;
		uint32_t sync_context;
		uint32_t preferredmaximumlength;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		uint32_t sync_context;
		struct netr_DELTA_ENUM_ARRAY *delta_enum_array;/* [unique] */
		NTSTATUS result;
	} out;

};


struct netr_AccountDeltas {
	struct {
		const char *logon_server;/* [charset(UTF16),unique,string] */
		const char *computername;/* [charset(UTF16),string] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		struct netr_UAS_INFO_0 uas;
		uint32_t count;
		uint32_t level;
		uint32_t buffersize;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		struct netr_AccountBuffer buffer;/* [subcontext(4)] */
		uint32_t count_returned;
		uint32_t total_entries;
		struct netr_UAS_INFO_0 recordid;
		NTSTATUS result;
	} out;

};


struct netr_AccountSync {
	struct {
		const char *logon_server;/* [charset(UTF16),unique,string] */
		const char *computername;/* [charset(UTF16),string] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		uint32_t reference;
		uint32_t level;
		uint32_t buffersize;
		struct netr_UAS_INFO_0 recordid;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		struct netr_AccountBuffer buffer;/* [subcontext(4)] */
		uint32_t count_returned;
		uint32_t total_entries;
		uint32_t next_reference;
		struct netr_UAS_INFO_0 recordid;
		NTSTATUS result;
	} out;

};


struct netr_GetDcName {
	struct {
		const char *logon_server;/* [string,charset(UTF16)] */
		const char *domainname;/* [unique,string,charset(UTF16)] */
	} in;

	struct {
		const char *dcname;/* [string,unique,charset(UTF16)] */
		NTSTATUS result;
	} out;

};


struct netr_LogonControl {
	struct {
		const char *logon_server;/* [charset(UTF16),unique,string] */
		enum netr_LogonControlCode function_code;
		uint32_t level;
	} in;

	struct {
		union netr_CONTROL_QUERY_INFORMATION info;/* [switch_is(level)] */
		WERROR result;
	} out;

};


struct netr_GetAnyDCName {
	struct {
		const char *logon_server;/* [charset(UTF16),unique,string] */
		const char *domainname;/* [charset(UTF16),unique,string] */
	} in;

	struct {
		const char *dcname;/* [charset(UTF16),unique,string] */
		WERROR result;
	} out;

};


struct netr_LogonControl2 {
	struct {
		const char *logon_server;/* [string,unique,charset(UTF16)] */
		uint32_t function_code;
		uint32_t level;
		union netr_CONTROL_DATA_INFORMATION data;/* [switch_is(function_code)] */
	} in;

	struct {
		union netr_CONTROL_QUERY_INFORMATION query;/* [switch_is(level)] */
		WERROR result;
	} out;

};


struct netr_ServerAuthenticate2 {
	struct {
		const char *server_name;/* [string,unique,charset(UTF16)] */
		const char *account_name;/* [string,charset(UTF16)] */
		enum netr_SchannelType secure_channel_type;
		const char *computer_name;/* [string,charset(UTF16)] */
		struct netr_Credential *credentials;/* [ref] */
		uint32_t *negotiate_flags;/* [ref] */
	} in;

	struct {
		struct netr_Credential *credentials;/* [ref] */
		uint32_t *negotiate_flags;/* [ref] */
		NTSTATUS result;
	} out;

};


struct netr_DatabaseSync2 {
	struct {
		const char *logon_server;/* [string,charset(UTF16)] */
		const char *computername;/* [charset(UTF16),string] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		enum netr_SamDatabaseID database_id;
		uint16_t restart_state;
		uint32_t sync_context;
		uint32_t preferredmaximumlength;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		uint32_t sync_context;
		struct netr_DELTA_ENUM_ARRAY *delta_enum_array;/* [unique] */
		NTSTATUS result;
	} out;

};


struct netr_DatabaseRedo {
	struct {
		const char *logon_server;/* [charset(UTF16),string] */
		const char *computername;/* [string,charset(UTF16)] */
		struct netr_Authenticator credential;
		struct netr_Authenticator return_authenticator;
		uint8_t *change_log_entry;/* [unique,size_is(change_log_entry_size)] */
		uint32_t change_log_entry_size;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		struct netr_DELTA_ENUM_ARRAY *delta_enum_array;/* [unique] */
		NTSTATUS result;
	} out;

};


struct netr_LogonControl2Ex {
	struct {
		const char *logon_server;/* [string,unique,charset(UTF16)] */
		uint32_t function_code;
		uint32_t level;
		union netr_CONTROL_DATA_INFORMATION data;/* [switch_is(function_code)] */
	} in;

	struct {
		union netr_CONTROL_QUERY_INFORMATION query;/* [switch_is(level)] */
		WERROR result;
	} out;

};


struct netr_NETRENUMERATETRUSTEDDOMAINS {
	struct {
		WERROR result;
	} out;

};


struct netr_DsRGetDCName {
	struct {
		const char *server_unc;/* [charset(UTF16),unique,string] */
		const char *domain_name;/* [charset(UTF16),string,unique] */
		struct GUID *domain_guid;/* [unique] */
		struct GUID *site_guid;/* [unique] */
		uint32_t flags;
	} in;

	struct {
		struct netr_DsRGetDCNameInfo *info;/* [unique] */
		WERROR result;
	} out;

};


struct netr_NETRLOGONDUMMYROUTINE1 {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRLOGONSETSERVICEBITS {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRLOGONGETTRUSTRID {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRLOGONCOMPUTESERVERDIGEST {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRLOGONCOMPUTECLIENTDIGEST {
	struct {
		WERROR result;
	} out;

};


struct netr_ServerAuthenticate3 {
	struct {
		const char *server_name;/* [string,unique,charset(UTF16)] */
		const char *account_name;/* [charset(UTF16),string] */
		enum netr_SchannelType secure_channel_type;
		const char *computer_name;/* [string,charset(UTF16)] */
		struct netr_Credential *credentials;/* [ref] */
		uint32_t *negotiate_flags;/* [ref] */
	} in;

	struct {
		struct netr_Credential *credentials;/* [ref] */
		uint32_t *negotiate_flags;/* [ref] */
		uint32_t *rid;/* [ref] */
		NTSTATUS result;
	} out;

};


struct netr_DsRGetDCNameEx {
	struct {
		const char *server_unc;/* [charset(UTF16),string,unique] */
		const char *domain_name;/* [charset(UTF16),string,unique] */
		struct GUID *domain_guid;/* [unique] */
		const char *site_name;/* [unique,string,charset(UTF16)] */
		uint32_t flags;
	} in;

	struct {
		struct netr_DsRGetDCNameInfo *info;/* [unique] */
		WERROR result;
	} out;

};


struct netr_DsRGetSiteName {
	struct {
		const char *computer_name;/* [charset(UTF16),string,unique] */
	} in;

	struct {
		const char *site;/* [unique,string,charset(UTF16)] */
		WERROR result;
	} out;

};


struct netr_LogonGetDomainInfo {
	struct {
		const char *server_name;/* [charset(UTF16),string] */
		const char *computer_name;/* [charset(UTF16),unique,string] */
		struct netr_Authenticator *credential;/* [ref] */
		struct netr_Authenticator *return_authenticator;/* [ref] */
		uint32_t level;
		union netr_DomainQuery query;/* [switch_is(level)] */
	} in;

	struct {
		struct netr_Authenticator *return_authenticator;/* [ref] */
		union netr_DomainInfo info;/* [switch_is(level)] */
		NTSTATUS result;
	} out;

};


struct netr_ServerPasswordSet2 {
	struct {
		const char *server_name;/* [charset(UTF16),string,unique] */
		const char *account_name;/* [charset(UTF16),string] */
		enum netr_SchannelType secure_channel_type;
		const char *computer_name;/* [string,charset(UTF16)] */
		struct netr_Authenticator credential;
		struct netr_CryptPassword new_password;
	} in;

	struct {
		struct netr_Authenticator return_authenticator;
		NTSTATUS result;
	} out;

};


struct netr_NETRSERVERPASSWORDGET {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRLOGONSENDTOSAM {
	struct {
		WERROR result;
	} out;

};


struct netr_DSRADDRESSTOSITENAMESW {
	struct {
		WERROR result;
	} out;

};


struct netr_DsRGetDCNameEx2 {
	struct {
		const char *server_unc;/* [charset(UTF16),unique,string] */
		const char *client_account;/* [charset(UTF16),string,unique] */
		uint32_t mask;
		const char *domain_name;/* [unique,string,charset(UTF16)] */
		struct GUID *domain_guid;/* [unique] */
		const char *site_name;/* [unique,string,charset(UTF16)] */
		uint32_t flags;
	} in;

	struct {
		struct netr_DsRGetDCNameInfo *info;/* [unique] */
		WERROR result;
	} out;

};


struct netr_NETRLOGONGETTIMESERVICEPARENTDOMAIN {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRENUMERATETRUSTEDDOMAINSEX {
	struct {
		WERROR result;
	} out;

};


struct netr_DSRADDRESSTOSITENAMESEXW {
	struct {
		WERROR result;
	} out;

};


struct netr_DSRGETDCSITECOVERAGEW {
	struct {
		WERROR result;
	} out;

};


struct netr_LogonSamLogonEx {
	struct {
		const char *server_name;/* [unique,string,charset(UTF16)] */
		const char *computer_name;/* [unique,string,charset(UTF16)] */
		uint16_t logon_level;
		union netr_LogonLevel logon;/* [switch_is(logon_level)] */
		uint16_t validation_level;
		uint32_t flags;
	} in;

	struct {
		union netr_Validation validation;/* [switch_is(validation_level)] */
		uint8_t authoritative;
		uint32_t flags;
		NTSTATUS result;
	} out;

};


struct netr_DsrEnumerateDomainTrusts {
	struct {
		const char *server_name;/* [charset(UTF16),string,unique] */
		uint32_t trust_flags;
	} in;

	struct {
		uint32_t count;
		struct netr_DomainTrust *trusts;/* [unique,size_is(count)] */
		WERROR result;
	} out;

};


struct netr_DSRDEREGISTERDNSHOSTRECORDS {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRSERVERTRUSTPASSWORDSGET {
	struct {
		WERROR result;
	} out;

};


struct netr_DSRGETFORESTTRUSTINFORMATION {
	struct {
		WERROR result;
	} out;

};


struct netr_NETRGETFORESTTRUSTINFORMATION {
	struct {
		WERROR result;
	} out;

};


struct netr_LogonSamLogonWithFlags {
	struct {
		const char *server_name;/* [charset(UTF16),unique,string] */
		const char *computer_name;/* [unique,string,charset(UTF16)] */
		struct netr_Authenticator *credential;/* [unique] */
		struct netr_Authenticator *return_authenticator;/* [unique] */
		uint16_t logon_level;
		union netr_LogonLevel logon;/* [switch_is(logon_level)] */
		uint16_t validation_level;
		uint32_t flags;
	} in;

	struct {
		struct netr_Authenticator *return_authenticator;/* [unique] */
		union netr_Validation validation;/* [switch_is(validation_level)] */
		uint8_t authoritative;
		uint32_t flags;
		NTSTATUS result;
	} out;

};


struct netr_NETRSERVERGETTRUSTINFO {
	struct {
		WERROR result;
	} out;

};

#endif /* _HEADER_netlogon */
